QwtPlotGrid Class Reference

A class which draws a coordinate grid. More...

`#include <qwt_plot_grid.h>`

Inheritance diagram for QwtPlotGrid:
[legend]

## Public Member Functions

| QwtPlotGrid ()
| Enables major grid, disables minor grid.
virtual | ~QwtPlotGrid ()
| Destructor.
virtual int | rtti () const
void | enableX (bool)
| Enable or disable vertical grid lines. More...
bool | xEnabled () const
void | enableY (bool)
| Enable or disable horizontal grid lines. More...
bool | yEnabled () const
void | enableXMin (bool)
| Enable or disable minor vertical grid lines. More...
bool | xMinEnabled () const
void | enableYMin (bool)
| Enable or disable minor horizontal grid lines. More...
bool | yMinEnabled () const
void | setXDiv (const QwtScaleDiv &)
const QwtScaleDiv & | xScaleDiv () const
void | setYDiv (const QwtScaleDiv &)
const QwtScaleDiv & | yScaleDiv () const
void | setPen (const QColor &, qreal width=0.0, Qt::PenStyle=Qt::SolidLine)
void | setPen (const QPen &)
void | setMajorPen (const QColor &, qreal width=0.0, Qt::PenStyle=Qt::SolidLine)
void | setMajorPen (const QPen &)
const QPen & | majorPen () const
void | setMinorPen (const QColor &, qreal width=0.0, Qt::PenStyle=Qt::SolidLine)
void | setMinorPen (const QPen &)
const QPen & | minorPen () const
virtual void | draw (QPainter *, const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QRectF &canvasRect) const
| Draw the grid. More...
virtual void | updateScaleDiv (const QwtScaleDiv &xScaleDiv, const QwtScaleDiv &yScaleDiv)
Public Member Functions inherited from QwtPlotItem
| QwtPlotItem (const QwtText &title=QwtText())
virtual | ~QwtPlotItem ()
| Destroy the QwtPlotItem.
void | attach (QwtPlot *plot)
| Attach the item to a plot. More...
void | detach ()
| This method detaches a QwtPlotItem from any QwtPlot it has been associated with. More...
QwtPlot * | plot () const
| Return attached plot.
void | setTitle (const QString &title)
void | setTitle (const QwtText &title)
const QwtText & | title () const
void | setItemAttribute (ItemAttribute, bool on=true)
bool | testItemAttribute (ItemAttribute) const
void | setItemInterest (ItemInterest, bool on=true)
bool | testItemInterest (ItemInterest) const
void | setRenderHint (RenderHint, bool on=true)
bool | testRenderHint (RenderHint) const
void | setRenderThreadCount (uint numThreads)
uint | renderThreadCount () const
void | setLegendIconSize (const QSize &)
QSize | legendIconSize () const
double | z () const
void | setZ (double z)
| Set the z value. More...
void | show ()
| Show the item.
void | hide ()
| Hide the item.
virtual void | setVisible (bool)
bool | isVisible () const
void | setAxes (int xAxis, int yAxis)
void | setXAxis (int axis)
int | xAxis () const
| Return xAxis.
void | setYAxis (int axis)
int | yAxis () const
| Return yAxis.
virtual void | itemChanged ()
virtual void | legendChanged ()
virtual QRectF | boundingRect () const
virtual void | getCanvasMarginHint (const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QRectF &canvasRect, double &left, double &top, double &right, double &bottom) const
| Calculate a hint for the canvas margin. More...
virtual void | updateLegend (const QwtPlotItem *, const QList< QwtLegendData > &)
| Update the item to changes of the legend info. More...
QRectF | scaleRect (const QwtScaleMap &, const QwtScaleMap &) const
| Calculate the bounding scale rectangle of 2 maps. More...
QRectF | paintRect (const QwtScaleMap &, const QwtScaleMap &) const
| Calculate the bounding paint rectangle of 2 maps. More...
virtual QList< QwtLegendData > | legendData () const
| Return all information, that is needed to represent the item on the legend. More...
virtual QwtGraphic | legendIcon (int index, const QSizeF &) const

## Additional Inherited Members

Public Types inherited from QwtPlotItem
enum | RttiValues { Rtti_PlotItem = 0, Rtti_PlotGrid, Rtti_PlotScale, Rtti_PlotLegend, Rtti_PlotMarker, Rtti_PlotCurve, Rtti_PlotSpectroCurve, Rtti_PlotIntervalCurve, Rtti_PlotHistogram, Rtti_PlotSpectrogram, Rtti_PlotSVG, Rtti_PlotTradingCurve, Rtti_PlotBarChart, Rtti_PlotMultiBarChart, Rtti_PlotShape, Rtti_PlotTextLabel, Rtti_PlotZone, Rtti_PlotUserItem = 1000 }
| Runtime type information. More...
enum | ItemAttribute { Legend = 0x01, AutoScale = 0x02, Margins = 0x04 }
| Plot Item Attributes. More...
enum | ItemInterest { ScaleInterest = 0x01, LegendInterest = 0x02 }
| Plot Item Interests. More...
enum | RenderHint { RenderAntialiased = 0x1 }
| Render hints. More...
typedef QFlags< ItemAttribute > | ItemAttributes
| Plot Item Attributes.
typedef QFlags< ItemInterest > | ItemInterests
| Plot Item Interests.
typedef QFlags< RenderHint > | RenderHints
| Render hints.
Protected Member Functions inherited from QwtPlotItem
QwtGraphic | defaultIcon (const QBrush &, const QSizeF &) const
| Return a default icon from a brush. More...

## Detailed Description

A class which draws a coordinate grid.

The QwtPlotGrid class can be used to draw a coordinate grid. A coordinate grid consists of major and minor vertical and horizontal grid lines. The locations of the grid lines are determined by the X and Y scale divisions which can be assigned with setXDiv() and setYDiv(). The draw() member draws the grid within a bounding rectangle.

## Member Function Documentation

## draw()

void QwtPlotGrid::draw | ( | QPainter * | painter,
|  | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | const QRectF & | canvasRect
| ) |  | const

virtual

Draw the grid.

The grid is drawn into the bounding rectangle such that grid lines begin and end at the rectangle's borders. The X and Y maps are used to map the scale divisions into the drawing region screen.

Parameters

  painter | Painter
  xMap | X axis map
  yMap | Y axis
  canvasRect | Contents rectangle of the plot canvas

Implements QwtPlotItem.

## enableX()

void QwtPlotGrid::enableX | ( | bool | on | ) |

Enable or disable vertical grid lines.

Parameters

  on | Enable (true) or disable

See also
  Minor grid lines can be enabled or disabled with enableXMin()

## enableXMin()

void QwtPlotGrid::enableXMin | ( | bool | on | ) |

Enable or disable minor vertical grid lines.

Parameters

  on | Enable (true) or disable

See also
  enableX()

## enableY()

void QwtPlotGrid::enableY | ( | bool | on | ) |

Enable or disable horizontal grid lines.

Parameters

  on | Enable (true) or disable

See also
  Minor grid lines can be enabled or disabled with enableYMin()

## enableYMin()

void QwtPlotGrid::enableYMin | ( | bool | on | ) |

Enable or disable minor horizontal grid lines.

Parameters

  on | Enable (true) or disable

See also
  enableY()

## majorPen()

const QPen & QwtPlotGrid::majorPen | ( |  | ) | const

Returns
  the pen for the major grid lines

See also
  setMajorPen(), setMinorPen(), setPen()

## minorPen()

const QPen & QwtPlotGrid::minorPen | ( |  | ) | const

Returns
  the pen for the minor grid lines

See also
  setMinorPen(), setMajorPen(), setPen()

## rtti()

int QwtPlotGrid::rtti | ( |  | ) | const

virtual

Returns
  QwtPlotItem::Rtti_PlotGrid

Reimplemented from QwtPlotItem.

## setMajorPen() [1/2]

void QwtPlotGrid::setMajorPen | ( | const QColor & | color,
|  | qreal | width = `0.0`,
|  | Qt::PenStyle | style = `Qt::SolidLine`
| ) |  |

Build and assign a pen for both major grid lines

In Qt5 the default pen width is 1.0 ( 0.0 in Qt4 ) what makes it non cosmetic ( see QPen::isCosmetic() ). This method has been introduced to hide this incompatibility.

Parameters

  color | Pen color
  width | Pen width
  style | Pen style

See also
  pen(), brush()

## setMajorPen() [2/2]

void QwtPlotGrid::setMajorPen | ( | const QPen & | pen | ) |

Assign a pen for the major grid lines

Parameters

  pen | Pen

See also
  majorPen(), setMinorPen(), setPen()

## setMinorPen() [1/2]

void QwtPlotGrid::setMinorPen | ( | const QColor & | color,
|  | qreal | width = `0.0`,
|  | Qt::PenStyle | style = `Qt::SolidLine`
| ) |  |

Build and assign a pen for the minor grid lines

In Qt5 the default pen width is 1.0 ( 0.0 in Qt4 ) what makes it non cosmetic ( see QPen::isCosmetic() ). This method has been introduced to hide this incompatibility.

Parameters

  color | Pen color
  width | Pen width
  style | Pen style

See also
  pen(), brush()

## setMinorPen() [2/2]

void QwtPlotGrid::setMinorPen | ( | const QPen & | pen | ) |

Assign a pen for the minor grid lines

Parameters

  pen | Pen

See also
  minorPen(), setMajorPen(), setPen()

## setPen() [1/2]

void QwtPlotGrid::setPen | ( | const QColor & | color,
|  | qreal | width = `0.0`,
|  | Qt::PenStyle | style = `Qt::SolidLine`
| ) |  |

Build and assign a pen for both major and minor grid lines

In Qt5 the default pen width is 1.0 ( 0.0 in Qt4 ) what makes it non cosmetic ( see QPen::isCosmetic() ). This method has been introduced to hide this incompatibility.

Parameters

  color | Pen color
  width | Pen width
  style | Pen style

See also
  pen(), brush()

## setPen() [2/2]

void QwtPlotGrid::setPen | ( | const QPen & | pen | ) |

Assign a pen for both major and minor grid lines

Parameters

  pen | Pen

See also
  setMajorPen(), setMinorPen()

## setXDiv()

void QwtPlotGrid::setXDiv | ( | const QwtScaleDiv & | scaleDiv | ) |

Assign an x axis scale division

Parameters

  scaleDiv | Scale division

## setYDiv()

void QwtPlotGrid::setYDiv | ( | const QwtScaleDiv & | scaleDiv | ) |

Assign a y axis division

Parameters

  scaleDiv | Scale division

## updateScaleDiv()

void QwtPlotGrid::updateScaleDiv | ( | const QwtScaleDiv & | xScaleDiv,
|  | const QwtScaleDiv & | yScaleDiv
| ) |  |

virtual

Update the grid to changes of the axes scale division

Parameters

  xScaleDiv | Scale division of the x-axis
  yScaleDiv | Scale division of the y-axis

See also
  QwtPlot::updateAxes()

Reimplemented from QwtPlotItem.

## xEnabled()

bool QwtPlotGrid::xEnabled | ( |  | ) | const

Returns
  true if vertical grid lines are enabled

See also
  enableX()

## xMinEnabled()

bool QwtPlotGrid::xMinEnabled | ( |  | ) | const

Returns
  true if minor vertical grid lines are enabled

See also
  enableXMin()

## xScaleDiv()

const QwtScaleDiv & QwtPlotGrid::xScaleDiv | ( |  | ) | const

Returns
  the scale division of the x axis

## yEnabled()

bool QwtPlotGrid::yEnabled | ( |  | ) | const

Returns
  true if horizontal grid lines are enabled

See also
  enableY()

## yMinEnabled()

bool QwtPlotGrid::yMinEnabled | ( |  | ) | const

Returns
  true if minor horizontal grid lines are enabled

See also
  enableYMin()

## yScaleDiv()

const QwtScaleDiv & QwtPlotGrid::yScaleDiv | ( |  | ) | const

Returns
  the scale division of the y axis